
import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Products.PloneTestCase import PloneTestCase

PloneTestCase.installProduct('ifSearchSpellSuggest')
PloneTestCase.setupPloneSite(products=('ifSearchSpellSuggest',))

from os import path

import_files = '/home/matiasb/projects/ifrepo/zproducts/ifSearchSpellSuggest/trunk/tests/import/'

class TestSynonymSuggest(PloneTestCase.PloneTestCase):

    def afterSetUp(self):
        self.setRoles(('Manager',))
        self.sug_tool = self.portal.ifSearchSpellSuggest_tool
        fw = self.portal.ifSearchSpellSuggest_tool._synForward
        bw = self.portal.ifSearchSpellSuggest_tool._synBackward
        fw['hiv'] = 'vih'
        bw['vih'] = 'hiv'
        fw['fall'] = 'autumn'
        bw['autumn'] = 'fall'

    def testGetSynonymKeys(self):
        syn = self.sug_tool.getSynonymKeys()
        self.assertEqual(syn, ['fall', 'hiv'])

    def testGetWordSynonym(self):
        syn = self.sug_tool.getWordSynonym('hiv')
        self.assertEqual(syn, 'vih')

    def testGetWordNoSynonym(self):
        syn = self.sug_tool.getWordSynonym('infection')
        self.assertEqual(syn, None)

    def testGetWordNoCaseSensitiveSynonym(self):
        syn = self.sug_tool.getWordSynonym('VIH')
        self.assertEqual(syn, 'hiv')

    def testAddWordSynonym(self):
        self.sug_tool.addWordSynonym('theater', 'theatre')
        syn = self.sug_tool.getWordSynonym('theater')
        self.assertEqual(syn, 'theatre')
        syn = self.sug_tool.getWordSynonym('theatre')
        self.assertEqual(syn, 'theater')
        syn = self.sug_tool.getWordSynonym('Theatre')
        self.assertEqual(syn, 'theater', 'It should be case sensitive')

    def testDelWordSynonym(self):
        self.sug_tool.delWordSynonym('theatre')
        syn = self.sug_tool.getWordSynonym('theater')
        self.assertEqual(syn, None)
        syn = self.sug_tool.getWordSynonym('theatre')
        self.assertEqual(syn, None)

    def testOneWordSynonymSuggest(self):
        suggestion = self.sug_tool.getSynonymSuggestion('autumn')
        self.assertEqual(suggestion, 'fall')

    def testKeywordsSynonymSuggest(self):
        suggestion = self.sug_tool.getSynonymSuggestion('infection hiv in autumn or summer')
        self.assertEqual(suggestion, 'infection vih in fall or summer')

    def testPhraseSynonymSuggest(self):
        suggestion = self.sug_tool.getSynonymSuggestion('"hiv in fall" or summer infection')
        self.assertEqual(suggestion, '"vih in autumn" or summer infection')

    def testNoSynonymSuggest(self):
        suggestion = self.sug_tool.getSynonymSuggestion('summer infection')
        self.assertEqual(suggestion, None)

    def testComplexSynonymSuggest(self):
        suggestion = self.sug_tool.getSynonymSuggestion('("hiv infection" or herpes) not africa')
        self.assertEqual(suggestion, '("vih infection" or herpes) not africa')

    def testImportSynonyms(self):
        filename = path.join(import_files, 'import.txt')
        f = file(filename)
        self.sug_tool.importWordSynonyms(f)
        self.assertEqual(self.sug_tool.getWordSynonym('hiv'), 'vih')
        self.assertEqual(self.sug_tool.getWordSynonym('car'), 'voiture')
        self.assertEqual(self.sug_tool.getWordSynonym('aids'), 'sida')

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestSynonymSuggest))
    return suite

if __name__ == '__main__':
    framework()

